#ifdef __cplusplus
#define EXPORT extern "C" __declspec(dllexport)
#else
#define EXPORT __declspec(dllexport)
#endif


#define		SUPlv_DBT_VIDNAME					"VID_0A2F"

#define		USB_MAXDEVICE						127

#define     SUPlv_RANGE_8BIT                  	0x00        //  8ޯ
#define     SUPlv_RANGE_16BIT                 	0x40        //  16ޯ
#define     SUPlv_RANGE_32BIT                 	0x80        //  32ޯ
#define     SUPlv_RANGE_64BIT                 	0xC0        //  64ޯ

#define     SUPlv_ADRS_LOW_MASK                	0x003F
#define     SUPlv_ADRS_HIGH_MASK               	0x3FC0
#define     SUPlv_RANGE_MASK                	0x00C0

#define		SUPlv_MEMDIR_READ					0
#define		SUPlv_MEMDIR_WRITE					1

#define		SUPlv_MAX_TRANSFER_SIZE				2097152

#define		SUPlv_XOR_PARAM						0xAAAAAAAA

//  ʐM
#define     SUPlv_DIRECTION_DEVICE_TO_HOST		0xC0        //  ޲  ν
#define     SUPlv_DIRECTION_HOST_TO_DEVICE		0x40        //  ν  ޲

//  ظ
#define     SUPlv_REQUEST_CLASS					0x01        //  1 : ׽ظ
#define     SUPlv_REQUEST_VENDER              	0x02        //  2 : ظ

//  ޯđI
#define     SUPlv_RECEPIENT_DEVICE            	0x00        //  ޲
#define     SUPlv_RECEPIENT_INTERFACE			0x01        //  ̪
#define     SUPlv_RECEPIENT_ENDPOINT          	0x02        //  ߲
#define     SUPlv_RECEPIENT_OTHER             	0x03        //  ̑

//	߲ıڽ
#define		SUPlv_WRITE_EP_ADRS					0x06
#define		SUPlv_READ_EP_ADRS					0x82

//  ظĺ
#define     SUPlv_VENDER_REQUEST_REGISTER     	0xB0
#define     SUPlv_VENDER_REQUEST_DATA         	0xB1
#define     SUPlv_VENDER_REQUEST_USBCONFIG    	0xB2
#define     SUPlv_VENDER_REQUEST_BOARDINFO    	0xB3
#define     SUPlv_VENDER_REQUEST_GPIODIR      	0xB4
#define     SUPlv_VENDER_REQUEST_GPIOWRITE    	0xB5
#define     SUPlv_VENDER_REQUEST_GPIOREAD     	0xB6
#define     SUPlv_VENDER_REQUEST_GPIFWAIT     	0xB7
#define     SUPlv_VENDER_REQUEST_GPIFWAVE     	0xB8
#define     SUPlv_VENDER_REQUEST_GPIFCLK      	0xB9
#define     SUPlv_VENDER_REQUEST_GPIFFLAG     	0xBA
#define     SUPlv_VENDER_REQUEST_8051CORE     	0xBB
#define     SUPlv_VENDER_REQUEST_I2CWRITE     	0xC0
#define     SUPlv_VENDER_REQUEST_I2CREAD      	0xC1
#define     SUPlv_VENDER_REQUEST_GETTEMP      	0xC2
#define     SUPlv_VENDER_REQUEST_WAVECHANGE    	0xC3
#define     SUPlv_VENDER_REQUEST_SUSPEND      	0xC4
#define     SUPlv_VENDER_REQUEST_REGISTER_EX    0xC6

//  ظĺ(Smart-IO2p)
#define     SUPlv_VENDER_REQUEST_REG_WRITE_EXIO2  	0xB1
#define     SUPlv_VENDER_REQUEST_REG_BURST_WRITE  	0xB2


//  USB̨޺޺
#define     SUPlv_USBCONFIG_START             	0xC1
#define     SUPlv_USBCONFIG_END               	0x41
#define     SUPlv_DONE_WAIT_SIZE              	65536
#define     SUPlv_CFG_STS_ADRS				    2
#define     SUPlv_CFG_STATUS_SUCCESS			0
#define		SUPlv_CFG_MODE_REG_ADRS				63
#define		SUPlv_CFG_MODE_INT					0x00
#define		SUPlv_CFG_MODE_EXT					0x01

//  ް]޺
#define     SUPlv_DATA_TRANS_OUT_START        	0xC0
#define     SUPlv_DATA_TRANS_OUT_END          	0x40
#define     SUPlv_DATA_TRANS_IN_START         	0x80
#define     SUPlv_DATA_TRANS_IN_END           	0x00

#define     SUPlv_CONFIG_MODE_ALTERA          	0
#define     SUPlv_CONFIG_MODE_XILINX          	1

//  ظ(B3h) ްޏ擾ނ̎擾I
#define     SUPlv_BOARDINFO_FIRMID            	0x00C0
#define     SUPlv_BOARDINFO_CHIPVER           	0x0080
#define     SUPlv_BOARDINFO_PID               	0x0040
#define     SUPlv_BOARDINFO_SPEED             	0x0000
#define     SUPlv_FULL_SPEED                  	0x0000
#define     SUPlv_HIGH_SPEED                  	0x0001

//	GPIFؓ]ӰޗpҰ
#define		SUPlv_GPIFWAVE_DIR_READ				0x0000
#define		SUPlv_GPIFWAVE_DIR_WRITE			0x0001
#define		SUPlv_GPIFWAVE_MODE_BURST			0x0000
#define		SUPlv_GPIFWAVE_MODE_WORD			0x0001








//  /۰ފ֐
EXPORT		BOOL	__stdcall	SUPlv_Usb_Open( UINT64 *dFoundHandle, UINT64 *dWinUSBHandle );
EXPORT		BOOL	__stdcall	SUPlv_Usb_Close( UINT64 dFoundHandle, UINT64 dWinUSBHandle );
EXPORT		BOOL	__stdcall	SUPlv_Get_Device_Handle( DWORD *num, UINT64 *dFoundHandle );
EXPORT		BOOL	__stdcall	SUPlv_Usb_Open_Handle( UINT64 dFoundHandle, UINT64 *dWinUSBHandle );
EXPORT		BOOL	__stdcall	SUPlv_Find_Device( DWORD adrs, DWORD id, UINT64 *dFoundHandle );

//  ްذ/ײĊ֐
EXPORT		BOOL	__stdcall	SUPlv_Data_Write( UINT64 dWinUSBHandle, BYTE range, DWORD FileSize, LPVOID pBuffer );
EXPORT		BOOL	__stdcall	SUPlv_Data_Read( UINT64 dWinUSBHandle, BYTE range, DWORD FileSize, LPVOID pBuffer );

EXPORT		BOOL	__stdcall	SUPlv_Bulk_Write( UINT64 dWinUSBHandle, DWORD WriteSize, LPVOID pBuffer );		//	Ver1.0.4.0Œǉ
EXPORT		BOOL	__stdcall	SUPlv_Bulk_Read( UINT64 dWinUSBHandle, DWORD ReadSize, LPVOID pBuffer );		//	Ver1.0.4.0Œǉ
EXPORT		BOOL	__stdcall	SUPlv_Mem_Cmd( UINT64 dWinUSBHandle, BYTE cmd, BYTE range );					//	Ver1.0.4.0Œǉ


//  ڼ޽֐
EXPORT		BOOL	__stdcall	SUPlv_Reg_Write( UINT64 dWinUSBHandle, DWORD adrs, DWORD range, UINT64 wd );
EXPORT		BOOL	__stdcall	SUPlv_Reg_Read( UINT64 dWinUSBHandle, DWORD adrs, DWORD range, UINT64 *rd );
EXPORT		BOOL	__stdcall	SUPlv_Reg_WriteEx( UINT64 dWinUSBHandle, DWORD adrs, DWORD size, BYTE *wd );
EXPORT		BOOL	__stdcall	SUPlv_Reg_ReadEx( UINT64 dWinUSBHandle, DWORD adrs, DWORD size, BYTE *rd );


//  հèè֐
EXPORT		BOOL	__stdcall	SUPlv_Get_BoardInfo( UINT64 dWinUSBHandle, DWORD Sel, DWORD *ID );
EXPORT		BOOL	__stdcall	SUPlv_Usb_Config( UINT64 dWinUSBHandle, TCHAR *PathName, bool Mode, bool Swap, bool Encrypt );
EXPORT		BOOL	__stdcall	SUPlv_I2c_Read( UINT64 dWinUSBHandle, DWORD DevAdrs, DWORD RegAdrs, BYTE *Rd );
EXPORT		BOOL	__stdcall	SUPlv_I2c_Write( UINT64 dWinUSBHandle, DWORD DevAdrs, DWORD RegAdrs, BYTE Wd );
EXPORT		BOOL	__stdcall	SUPlv_Get_FPGA_Temp( UINT64 dWinUSBHandle, WORD Sel, WORD *Temp );
EXPORT		BOOL	__stdcall	SUPlv_Suspend( UINT64 dWinUSBHandle, WORD mode );
EXPORT		BOOL	__stdcall	SUPlv_GPIO_Dir( UINT64 dWinUSBHandle, WORD port, WORD dir );
EXPORT		BOOL	__stdcall	SUPlv_GPIO_Read( UINT64 dWinUSBHandle, WORD port, BYTE *Rd );
EXPORT		BOOL	__stdcall	SUPlv_GPIO_Write( UINT64 dWinUSBHandle, WORD port, BYTE Wd );
EXPORT		BOOL	__stdcall	SUPlv_GPIF_Set_Wave( UINT64 dWinUSBHandle, WORD dir, WORD sel );
EXPORT		BOOL	__stdcall	SUPlv_GPIF_Reg_Wait( UINT64 dHandle, WORD dir, BYTE num );

//	2015.02.21ǉ	M.YOSHIDA
EXPORT		BOOL	__stdcall	SUPlv_Usb_Config_KXCARD7( UINT64 dWinUSBHandle, TCHAR *PathName, bool Encrypt );
EXPORT		BOOL	__stdcall	SUPlv_Usb_Config_CXCARD5( UINT64 dWinUSBHandle, TCHAR *PathName );

//	2016.10.06ǉ	M.YOSHIDA
EXPORT		BOOL	__stdcall	SUPlv_Usb_Deconfig( UINT64 dWinUSBHandle );

//	Smart-IO2ްސp
EXPORT		BOOL	__stdcall	SUPlv_Reg_Burst_Write( UINT64 dWinUSBHandle, DWORD adrs, DWORD length, BYTE *Wd );
EXPORT		BOOL	__stdcall	SUPlv_Reg_WriteExIO2( UINT64 dWinUSBHandle, DWORD adrs, BYTE wd );



//	۰ي֐(հްںقKvȂ)
BOOL	GetDeviceHandle( GUID guidDeviceInterface, PHANDLE hDeviceHandle );
BOOL	Mem_Cmd( UINT64 dWinUSBHandle, BYTE cmd, BYTE range );
